// serial.h : Header file for serial.cpp

#ifndef CSERIAL_H
#define CSERIAL_H


/*******************************************************************************
*                           OPEN SOURCE CODE DISCLAIMER                        *
* FILE NAME:          rs4.h                                                    *
* DATE:               December 2001                                            *
* VERSION:            0.02                                                     *
* PURPOSE:            Control a Leuze RotoScan 4 Laser Unit with a Serial Port *
* ORIGINAL CODE BY:   Juan Andrade Cetto & ALbert Checa Puimedon			   *   
*                     (C) Institut de Robtica Industrial                      *
*                     Universidad Politcnica de Catalunya                     *
* MODIFIED:			  Juan Fernando Florez M. Universidad del Cauca	           *
* DATE:				  Julio 2004											   *	
* ALGORITHM BASED ON: RS4_protocol_extern-e.doc (1.0) Leuze electronic         *
* CONTRIBUTOR(S):                                                              *
*                                                                              *
* The contents of this file are subject to the Mozilla Public License; you may *
* not use this file except in compliance with the License. You may obtain a    *
* copy of the License at http://www.mozilla.org/MPL/                           *
* Software distributed under the License is distributed on an "AS IS" basis,   *
* WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for *
* the specific language governing rights and limitations under the License.    *
*                                                                              *
* You may modify this code (or portions thereof) provided a copy of this       *
* disclaimer is included in the modified version.                              *
*******************************************************************************/


#include <stdio.h>
#include <conio.h>
#include <afxmt.h>

typedef HANDLE portstream_fd; 
#define TIMEOUT_CHAR_READ		-1
#define NO_PARITY				0x00
#define EVEN_PARITY				0x18
#define ODD_PARITY				0x08


	//Funciones Serial
	
	//! Open a serial communications port. 
	//@param portname
	//@returns portstream handle if succesfully opened, otherwise NULL
	portstream_fd openserial(char*);
	
	//! Close a serial communications port. 
	//@param portstream_hd handle to a portstream
	//@returns if succesfully closed, otherwise -1
	char closeserial(portstream_fd);
	
	//! Set serial communications parameters. 
	//@param portname
	//@param speed
	//@param parity
	//@param bits
	//@param stopbit
	//@returns handle to opened portstream
	portstream_fd setserial(char*, int, int, int, int);

	//! Read one chars from the serial port
	//@param pstream
	//@param buffer
	//@param char count
	//@param timeout
	//@returns TRUE if succesful
	char serialbytesin (portstream_fd, unsigned char*, unsigned int, long);

	// Output a string to the serial port
	//@param pstream
	//@param buffer
	//@param char count
	char SerialStringOut(portstream_fd, unsigned char*,int);	
		
 
#endif